#include <cassert>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 110;
const int maxT = 510;

int T, a, b;
bool vis[maxT][maxn][maxn];
int frT[maxT][maxn][maxn], frm[maxT][maxn][maxn];
int fri[maxT][maxn][maxn], frj[maxT][maxn][maxn];

void pass(int t, int i, int j, int mask)
{
    int ii = i, jj = j;
    if (mask & 1) i = a-i;
    if (mask & 2) j = b-j;
    if (i+j) {
        int delta = min(i, j);
        if (!delta) delta = max(i, j);
        if (t+delta > T) return;
        if (i > 0) i -= delta;
        if (j > 0) j -= delta;
        //cout << "pass " << t << " " << ii << " " << jj << " by " << mask << " -> " << t + delta << " " << i << " " << j << endl;
        if (!vis[t+delta][i][j]) {
            vis[t+delta][i][j] = true;
            frT[t+delta][i][j] = t;
            frm[t+delta][i][j] = mask;
            fri[t+delta][i][j] = ii;
            frj[t+delta][i][j] = jj;
        }
    }
}

vector<pair<int, int> > rec(int t, int i, int j)
{
    //cout << "state "  << t << " " << i << " " << j << endl;
    vector<pair<int, int> > res;
    if (!t) return res;
    res = rec(frT[t][i][j], fri[t][i][j], frj[t][i][j]);
    if (frm[t][i][j])
        res.push_back(make_pair(frT[t][i][j], frm[t][i][j]));
    return res;
}

int main()
{
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    
    int tests_num;
    cin >> tests_num;
    
    for (int sc = 0; sc < tests_num; sc++) {
    
        memset(vis, 0, sizeof(vis));
    
        cin >> T >> a >> b;
    
        vis[0][0][0] = true;
        for (int t = 0; t < T; t++)
            for (int i = 0; i <= a; i++)
                for (int j = 0; j <= b; j++)
                    if (vis[t][i][j]) {
                        for (int mask = 0; mask < 4; mask++)
                            pass(t, i, j, mask);
                    }
    
        if (vis[T][0][0]) {
            //cout << "YES" << endl;
            vector<pair<int, int> > ans = rec(T, 0, 0);
            cout << ans.size() << endl;
            for (int i = 0; i < ans.size(); i++) {
                cout << ans[i].first << " " << ans[i].second << endl;
            }
        } else cout << "NO" << endl; //гарантируется, что таких тестов нет
    
    }
    
    fclose(stdin); fclose(stdout);
    return 0;
}

